#include <cstdio>
#include <vector>
using namespace std;

const int maxV=50002;
int V, E;
struct {vector<int> s;} a[maxV];
struct {vector<int> s;} ar[maxV];

int p[maxV], cr[maxV];

void input()
{ scanf("%d%d",&V, &E);
  for(int i=1;i<=E;i++)
  { int v1, v2;
    scanf("%d%d",&v1, &v2);
    a[v1].s.push_back(v2);
    a[v2].s.push_back(v1);        
  }    
}

int c=0;
int beg, croot=0;
int mdfs(int v)
{ int min=c;
  p[v]=c; c++;
  for (int j=0; j<a[v].s.size(); j++) 
  {
   int i=a[v].s[j];
   if(p[i]==-1) 
    {
     if(beg==v) croot++;
     int m=mdfs(i);
     if(m>=p[v]) cr[v]=1;
     if(m<min)min=m;
    }
   else if(p[i]<min) min=p[i];
  } 
  return min;
}

int Vr;
void remove_vertex(int v)
{
  for(int i=0;i<V;i++) ar[i].s.clear();
//  printf("\n clear: \n");
//  for(int i=0;i<V;i++)
//  { printf("i=%i: ",i);
//    for (int j=0; j<ar[i].s.size(); j++) printf(" %i ", ar[i].s[j]); 
//    printf("\n");
//  }
  
  
  
  int ir=-1;
  for(int i=0;i<V;i++)
  { 

    ir++;
    if(ir==v)continue;
    for (int j=0; j<a[i].s.size(); j++)
     { int it=a[i].s[j];
       if(it!=v) ar[ir].s.push_back(it);
     }
  }

}

int cv;

int rdfs(int v)
{
  p[v]=1; cv++;

  for (int j=0; j<ar[v].s.size(); j++) 
  {
   int i=ar[v].s[j];
   if(p[i]==0) 
    {
     rdfs(i);
    }
  }  
}  
  
int maxcounter=0;  
  
void run(int vr)
{  

  remove_vertex(vr);
  
  int counter=-1;

  memset(p,0,V*sizeof(int));
  cv=-1;
  while(cv<V-1)
  {
   int nv=0; while(p[nv]!=0) nv++;
   rdfs(nv);
   counter++;

  }
  

  if(maxcounter<counter)maxcounter=counter;
}




int main()
{ input(); memset(p,-1,V*sizeof(int));
  
  beg=6;
  mdfs(beg);
  
  int b=0;
  for(int j=0;j<V;j++) b += cr[j];
  
  if(croot==1) {b--; cr[beg]=0;}
  
  printf("%d ",b);


  
  for(int vr=0;vr<=V;vr++)
  if(cr[vr]) run(vr);
 
  printf("%i\n",maxcounter);
 
}
  
 

