#include<cstdio>
#include<cmath>
#include<algorithm>
using namespace std;

bool cv(int ax, int ay, int bx, int by, int x, int y1, int y2)
{
 if((ax<x)&(bx<x)) return false;
 if((ax>x)&(bx>x)) return false;
 if(ax>bx){swap(ax,bx);swap(ay,by);}
 if(y1>y2)swap(y1,y2);
 double d = ((double)(x-ax)/(bx-ax))*(by-ay);   
 double cy=ay+d;
 if(cy<y1) return false;
 if(cy>y2) return false;
 return true;
} 

double dist(int ax, int ay, int bx, int by)
{
  return sqrt((double)(ax-bx)*(ax-bx)+(ay-by)*(ay-by));
}

int main()

{
  int ax, ay, bx, by, x, y1, y2;
  scanf("%i%i%i%i%i%i%i", &ax,&ay,&bx,&by,&x,&y1,&y2);
  double r;
  if(!cv(ax,ay,bx,by,x,y1,y2)) r=dist(ax,ay,bx,by);
  else
  {
   double d1=dist(ax,ay,x,y1)+dist(x,y1,bx,by);
   double d2=dist(ax,ay,x,y2)+dist(x,y2,bx,by);
   r=min(d1,d2);
  }
   r=((int)(r*10000.0))/10000.0;
   printf("%0.5lf",r);
}
